version: '2.2'
services:
  es-master:
    image: docker.elastic.co/elasticsearch/elasticsearch:7.12.0
    container_name: es-master
    command: ["sh", "-c", "/usr/share/elasticsearch/bin/elasticsearch-plugin install repository-s3 -s --batch && /usr/local/bin/docker-entrypoint.sh"]
    environment:
      - node.name=es-master
      - cluster.name=es-docker-cluster
      - discovery.seed_hosts=es-ingest,es-hot,es-cold
      - cluster.initial_master_nodes=es-master
      - bootstrap.memory_lock=true
      - "ES_JAVA_OPTS=-Xms512m -Xmx512m"
      - xpack.security.enabled=true
      - ELASTIC_USERNAME=$ELASTIC_USERNAME
      - ELASTIC_PASSWORD=$ELASTIC_PASSWORD
    ulimits:
      memlock:
        soft: -1
        hard: -1
    volumes:
      - data-master:/usr/share/elasticsearch/data
    ports:
      - 9200:9200
    networks:
      - elastic
  es-ingest:
    image: docker.elastic.co/elasticsearch/elasticsearch:7.12.0
    container_name: es-ingest
    command: ["sh", "-c", "/usr/share/elasticsearch/bin/elasticsearch-plugin install repository-s3 -s --batch && /usr/local/bin/docker-entrypoint.sh"]
    environment:
      - node.name=es-ingest
      - cluster.name=es-docker-cluster
      - discovery.seed_hosts=es-master,es-hot,es-cold
      - cluster.initial_master_nodes=es-master
      - bootstrap.memory_lock=true
      - "ES_JAVA_OPTS=-Xms512m -Xmx512m"
      - node.roles=ingest
    ulimits:
      memlock:
        soft: -1
        hard: -1
    volumes:
      - data-ingest:/usr/share/elasticsearch/data
    networks:
      - elastic
  es-hot:
    image: docker.elastic.co/elasticsearch/elasticsearch:7.12.0
    container_name: es-hot
    command: ["sh", "-c", "/usr/share/elasticsearch/bin/elasticsearch-plugin install repository-s3 -s --batch && /usr/local/bin/docker-entrypoint.sh"]
    environment:
      - node.name=es-hot
      - cluster.name=es-docker-cluster
      - discovery.seed_hosts=es-master,es-ingest,es-cold
      - cluster.initial_master_nodes=es-master
      - bootstrap.memory_lock=true
      - "ES_JAVA_OPTS=-Xms512m -Xmx512m"
      - node.roles=data_hot
    ulimits:
      memlock:
        soft: -1
        hard: -1
    volumes:
      - data-hot:/usr/share/elasticsearch/data
    networks:
      - elastic
  es-cold:
    image: docker.elastic.co/elasticsearch/elasticsearch:7.12.0
    container_name: es-cold
    command: ["sh", "-c", "/usr/share/elasticsearch/bin/elasticsearch-plugin install repository-s3 -s --batch && /usr/local/bin/docker-entrypoint.sh"]
    environment:
      - node.name=es-cold
      - cluster.name=es-docker-cluster
      - discovery.seed_hosts=es-master,es-ingest,es-hot
      - cluster.initial_master_nodes=es-master
      - bootstrap.memory_lock=true
      - "ES_JAVA_OPTS=-Xms512m -Xmx512m"
      - node.roles=data_cold
    ulimits:
      memlock:
        soft: -1
        hard: -1
    volumes:
      - data-cold:/usr/share/elasticsearch/data
    networks:
      - elastic

  kibana:
    image: docker.elastic.co/kibana/kibana:7.12.0
    container_name: kibana
    ports:
      - "5601:5601"
    volumes:
      - ./kibana.yml:/usr/share/kibana/config/kibana.yml
    networks:
      - elastic
    depends_on:
      - es-master
  minio:
    image: minio/minio:RELEASE.2021-04-22T15-44-28Z
    container_name: minio
    command: server /data
    environment:
      - MINIO_ACCESS_KEY=$MINIO_ACCESS_KEY
      - MINIO_SECRET_KEY=$MINIO_SECRET_KEY
    ports:
      - 9000:9000
    volumes:
      - /data:/home/hkhedher/workspace/data/minio
    networks:
      - elastic

volumes:
  data-master:
    driver: local
  data-ingest:
    driver: local
  data-hot:
    driver: local
  data-cold:
    driver: local

networks:
  elastic:
    driver: bridge
 
